Index: /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/ZDF/zdfosm.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/ZDF/zdfosm.F90	(revision 11144)
+++ /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/ZDF/zdfosm.F90	(revision 11145)
@@ -1551,12 +1774,13 @@
            WRITE(numout,*) ' ===>>>> :  wn not in restart file, set to zero initially'
         END IF
+
         id1 = iom_varid( numror, 'hbl'   , ldstop = .FALSE. )
-        id2 = iom_varid( numror, 'hbli'   , ldstop = .FALSE. )
+        id2 = iom_varid( numror, 'dh'   , ldstop = .FALSE. )
         IF( id1 > 0 .AND. id2 > 0) THEN                       ! 'hbl' exists; read and return
            CALL iom_get( numror, jpdom_autoglo, 'hbl' , hbl , ldxios = lrxios )
-           CALL iom_get( numror, jpdom_autoglo, 'hbli', hbli, ldxios = lrxios  )
-           WRITE(numout,*) ' ===>>>> :  hbl & hbli read from restart file'
+           CALL iom_get( numror, jpdom_autoglo, 'dh', dh, ldxios = lrxios  )
+           WRITE(numout,*) ' ===>>>> :  hbl & dh read from restart file'
            RETURN
-        ELSE                      ! 'hbl' & 'hbli' not in restart file, recalculate
+        ELSE                      ! 'hbl' & 'dh' not in restart file, recalculate
            WRITE(numout,*) ' ===>>>> : previous run without osmosis scheme, hbl computed from stratification'
         END IF
@@ -1570,5 +1794,5 @@
          CALL iom_rstput( kt, nitrst, numrow, 'wn'     , wn  , ldxios = lwxios )
          CALL iom_rstput( kt, nitrst, numrow, 'hbl'    , hbl , ldxios = lwxios )
-         CALL iom_rstput( kt, nitrst, numrow, 'hbli'   , hbli, ldxios = lwxios )
+         CALL iom_rstput( kt, nitrst, numrow, 'dh'     , dh, ldxios = lwxios )
         RETURN
      END IF
@@ -1578,5 +1802,4 @@
      !!-----------------------------------------------------------------------------
      IF( lwp ) WRITE(numout,*) ' ===>>>> : calculating hbl computed from stratification'
-     ALLOCATE( imld_rst(jpi,jpj) )
      ! w-level of the mixing and mixed layers
      CALL eos_rab( tsn, rab_n )
@@ -1599,12 +1822,12 @@
      DO jj = 1, jpj
         DO ji = 1, jpi
-           iiki = imld_rst(ji,jj)
-           hbl (ji,jj) = gdepw_n(ji,jj,iiki  ) * ssmask(ji,jj)    ! Turbocline depth
+           iiki = MAX(4,imld_rst(ji,jj))
+           hbl (ji,jj) = gdepw_n(ji,jj,iiki  )    ! Turbocline depth
+           dh (ji,jj) = e3t_n(ji,jj,iiki-1  )     ! Turbocline depth
         END DO
      END DO
-     hbl = MAX(hbl,epsln)
-     hbli(:,:) = hbl(:,:)
-     DEALLOCATE( imld_rst )
      WRITE(numout,*) ' ===>>>> : hbl computed from stratification'
+     wn(:,:,:) = 0._wp
+     WRITE(numout,*) ' ===>>>> :  wn not in restart file, set to zero initially'
    END SUBROUTINE osm_rst
 
@@ -1634,5 +1857,4 @@
       ENDIF
 
-      ! add non-local temperature and salinity flux
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
@@ -1648,12 +1870,11 @@
       END DO
 
-
-      ! save the non-local tracer flux trends for diagnostic
+      ! save the non-local tracer flux trends for diagnostics
       IF( l_trdtra )   THEN
          ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
          ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
-!!bug gm jpttdzdf ==> jpttosm
-         CALL trd_tra( kt, 'TRA', jp_tem, jptra_zdf, ztrdt )
-         CALL trd_tra( kt, 'TRA', jp_sal, jptra_zdf, ztrds )
+
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_osm, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_osm, ztrds )
          DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds )
       ENDIF
@@ -1723,3 +1944,4 @@
 
    !!======================================================================
+
 END MODULE zdfosm
Index: /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/step.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/step.F90	(revision 11144)
+++ /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/step.F90	(revision 11145)
@@ -101,5 +101,6 @@
       IF( kstp == nit000 ) THEN                       ! initialize IOM context (must be done after nemo_init for AGRIF+XIOS+OASIS)
                              CALL iom_init(      cxios_context          )  ! for model grid (including passible AGRIF zoom)
-         IF( ln_crs      )   CALL iom_init( TRIM(cxios_context)//"_crs" )  ! for coarse grid
+                             IF( ln_crs      )   CALL iom_init( TRIM(cxios_context)//"_crs" )  ! for coarse grid
+                             CALL dia_hth_init    ! extra ML depth diagnostics, thermocline depths
       ENDIF
       IF( kstp /= nit000 )   CALL day( kstp )         ! Calendar (day was already called at nit000 in day_init)
@@ -212,9 +213,9 @@
       ! diagnostics and outputs
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      IF( lk_floats  )   CALL flo_stp ( kstp )        ! drifting Floats
-      IF( ln_diacfl  )   CALL dia_cfl ( kstp )        ! Courant number diagnostics
-      IF( lk_diahth  )   CALL dia_hth ( kstp )        ! Thermocline depth (20 degres isotherm depth)
-      IF( lk_diadct  )   CALL dia_dct ( kstp )        ! Transports
-                         CALL dia_ar5 ( kstp )        ! ar5 diag
+      IF( lk_floats  )   CALL flo_stp( kstp )         ! drifting Floats
+      IF( ln_diacfl  )   CALL dia_cfl( kstp )         ! Courant number diagnostics
+      IF( ll_diahth  )   CALL dia_hth( kstp )         ! Thermocline depth (20 degres isotherm depth)
+      IF( lk_diadct  )   CALL dia_dct( kstp )         ! Transports
+                         CALL dia_ar5( kstp )         ! ar5 diag
       IF( lk_diaharm )   CALL dia_harm( kstp )        ! Tidal harmonic analysis
                          CALL dia_wri ( kstp )        ! ocean model: outputs
Index: /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/stpctl.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/stpctl.F90	(revision 11144)
+++ /NEMO/branches/UKMO/NEMO_4.0_OSMOSIS/src/OCE/stpctl.F90	(revision 11145)
@@ -66,6 +66,6 @@
       INTEGER, DIMENSION(3)  ::   iu, is1, is2        ! min/max loc indices
       REAL(wp)               ::   zzz                 ! local real 
-      REAL(wp), DIMENSION(9) ::   zmax
-      LOGICAL                ::   ll_wrtstp, ll_colruns, ll_wrtruns
+      REAL(wp), DIMENSION(10) ::   zmax
+      LOGICAL                ::   ll_wrtstp, ll_colruns, ll_wrtruns, ll_isnan
       CHARACTER(len=20) :: clname
       !!----------------------------------------------------------------------
@@ -109,4 +109,6 @@
       ENDIF
       !
+      ll_isnan = ANY(ISNAN(tsn)) .OR. ANY(ISNAN(un))
+      IF (ll_isnan) nstop = nstop + 1
       !                                   !==  test of extrema  ==!
       IF( ll_wd ) THEN
@@ -124,4 +126,9 @@
          zmax(8) = MAXVAL(  ABS( wi(:,:,:) ) , mask = wmask(:,:,:) == 1._wp ) ! implicit vertical vel. max
          zmax(9) = MAXVAL(   Cu_adv(:,:,:)   , mask = tmask(:,:,:) == 1._wp ) !       cell Courant no. max
+      ENDIF
+      IF (ll_isnan) THEN
+         zmax(10) = 1._wp                                           ! stop indicator
+      ELSE
+         zmax(10) = 0._wp
       ENDIF
       !
@@ -147,5 +154,5 @@
       END IF
       !                                   !==  error handling  ==!
-      IF( ( ln_ctl .OR. lsomeoce ) .AND. (   &             ! have use mpp_max (because ln_ctl=.T.) or contains some ocean points
+      IF( ( (ln_ctl .OR. sn_cfctl%l_runstat) .OR. lsomeoce ) .AND. (   &             ! have use mpp_max (because ln_ctl=.T.) or contains some ocean points
          &  zmax(1) >   20._wp .OR.   &                    ! too large sea surface height ( > 20 m )
          &  zmax(2) >   10._wp .OR.   &                    ! too large velocity ( > 10 m/s)
@@ -153,6 +160,7 @@
          &  zmax(4) >= 100._wp .OR.   &                    ! too large sea surface salinity ( > 100 )
          &  zmax(4) <    0._wp .OR.   &                    ! too large sea surface salinity (keep this line for sea-ice)
-         &  ISNAN( zmax(1) + zmax(2) + zmax(3) ) ) ) THEN   ! NaN encounter in the tests
-         IF( lk_mpp .AND. ln_ctl ) THEN
+         &  zmax(10) >   0._wp  ) ) THEN   ! NaN encounter in the tests
+         ! &  ISNAN( zmax(1) + zmax(2) + zmax(3) ) ) ) THEN   ! NaN encounter in the tests
+         IF( lk_mpp .AND. (ln_ctl .OR. sn_cfctl%l_runstat)) THEN
             CALL mpp_maxloc( 'stpctl', ABS(sshn)        , ssmask(:,:)  , zzz, ih  )
             CALL mpp_maxloc( 'stpctl', ABS(un)          , umask (:,:,:), zzz, iu  )
